# coding: utf-8

"""
    Lightly API

    Lightly.ai enables you to do self-supervised learning in an easy and intuitive way. The lightly.ai OpenAPI spec defines how one can interact with our REST API to unleash the full potential of lightly.ai  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: support@lightly.ai
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import Extra,  BaseModel, Field, StrictBool, StrictStr, conint, constr, validator

class DatasetEmbeddingData(BaseModel):
    """
    DatasetEmbeddingData
    """
    id: constr(strict=True) = Field(..., description="MongoDB ObjectId")
    name: StrictStr = Field(..., description="name of the embedding chosen by the user calling writeCSVUrl")
    is_processed: StrictBool = Field(..., alias="isProcessed", description="indicator whether embeddings have already been processed by a background worker")
    created_at: conint(strict=True, ge=0) = Field(..., alias="createdAt", description="unix timestamp in milliseconds")
    is2d: Optional[StrictBool] = Field(None, description="flag set by the background worker if the embedding is 2d")
    __properties = ["id", "name", "isProcessed", "createdAt", "is2d"]

    @validator('id')
    def id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"^[a-f0-9]{24}$", value):
            raise ValueError(r"must validate the regular expression /^[a-f0-9]{24}$/")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True
        use_enum_values = True
        extra = Extra.forbid

    def to_str(self, by_alias: bool = False) -> str:
        """Returns the string representation of the model"""
        return pprint.pformat(self.dict(by_alias=by_alias))

    def to_json(self, by_alias: bool = False) -> str:
        """Returns the JSON representation of the model"""
        return json.dumps(self.to_dict(by_alias=by_alias))

    @classmethod
    def from_json(cls, json_str: str) -> DatasetEmbeddingData:
        """Create an instance of DatasetEmbeddingData from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self, by_alias: bool = False):
        """Returns the dictionary representation of the model"""
        _dict = self.dict(by_alias=by_alias,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> DatasetEmbeddingData:
        """Create an instance of DatasetEmbeddingData from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return DatasetEmbeddingData.parse_obj(obj)

        # raise errors for additional fields in the input
        for _key in obj.keys():
            if _key not in cls.__properties:
                raise ValueError("Error due to additional fields (not defined in DatasetEmbeddingData) in the input: " + str(obj))

        _obj = DatasetEmbeddingData.parse_obj({
            "id": obj.get("id"),
            "name": obj.get("name"),
            "is_processed": obj.get("isProcessed"),
            "created_at": obj.get("createdAt"),
            "is2d": obj.get("is2d")
        })
        return _obj

