# coding: utf-8

"""
    Lightly API

    Lightly.ai enables you to do self-supervised learning in an easy and intuitive way. The lightly.ai OpenAPI spec defines how one can interact with our REST API to unleash the full potential of lightly.ai  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: support@lightly.ai
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Union
from pydantic import Extra,  BaseModel, Field, StrictFloat, StrictInt, StrictStr, conlist
from lightly.openapi_generated.swagger_client.models.dimensionality_reduction_method import DimensionalityReductionMethod

class Embedding2dCreateRequest(BaseModel):
    """
    Embedding2dCreateRequest
    """
    name: StrictStr = Field(..., description="Name of the 2d embedding (default is embedding name + __2d)")
    dimensionality_reduction_method: DimensionalityReductionMethod = Field(..., alias="dimensionalityReductionMethod")
    coordinates_dimension1: conlist(Union[StrictFloat, StrictInt], min_items=1) = Field(..., alias="coordinatesDimension1", description="Array of coordinates of a 2d embedding")
    coordinates_dimension2: conlist(Union[StrictFloat, StrictInt], min_items=1) = Field(..., alias="coordinatesDimension2", description="Array of coordinates of a 2d embedding")
    __properties = ["name", "dimensionalityReductionMethod", "coordinatesDimension1", "coordinatesDimension2"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True
        use_enum_values = True
        extra = Extra.forbid

    def to_str(self, by_alias: bool = False) -> str:
        """Returns the string representation of the model"""
        return pprint.pformat(self.dict(by_alias=by_alias))

    def to_json(self, by_alias: bool = False) -> str:
        """Returns the JSON representation of the model"""
        return json.dumps(self.to_dict(by_alias=by_alias))

    @classmethod
    def from_json(cls, json_str: str) -> Embedding2dCreateRequest:
        """Create an instance of Embedding2dCreateRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self, by_alias: bool = False):
        """Returns the dictionary representation of the model"""
        _dict = self.dict(by_alias=by_alias,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Embedding2dCreateRequest:
        """Create an instance of Embedding2dCreateRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Embedding2dCreateRequest.parse_obj(obj)

        # raise errors for additional fields in the input
        for _key in obj.keys():
            if _key not in cls.__properties:
                raise ValueError("Error due to additional fields (not defined in Embedding2dCreateRequest) in the input: " + str(obj))

        _obj = Embedding2dCreateRequest.parse_obj({
            "name": obj.get("name"),
            "dimensionality_reduction_method": obj.get("dimensionalityReductionMethod"),
            "coordinates_dimension1": obj.get("coordinatesDimension1"),
            "coordinates_dimension2": obj.get("coordinatesDimension2")
        })
        return _obj

